
from pyramid import testing

from rattail.pyramid.tests import TestCase
from rattail.pyramid.views import departments

from rattail.db.model import Department


class DepartmentTests(TestCase):
    """
    Test Department views.
    """

    def test_grid(self):
        request = testing.DummyRequest(has_perm=lambda p: True)
        view = departments.DepartmentsGrid(request)
        view._data = None
        view._sort_config = None
        self.assertIsInstance(view, departments.DepartmentsGrid)
        self.assertIsInstance(view.filter_map(), dict)
        self.assertIsInstance(view.filter_config(), dict)
        self.assertIsInstance(view.sort_map(), dict)
        self.assertIsInstance(view.grid(), object)

    def test_crud(self):
        request = testing.DummyRequest()
        view = departments.DepartmentCrud(request)
        self.assertIsInstance(view, departments.DepartmentCrud)
        self.assertIsInstance(view.fieldset(Department), object)

    def test_autocomplete(self):
        request = testing.DummyRequest()
        view = departments.DepartmentsAutocomplete(request)
        self.assertIsInstance(view, departments.DepartmentsAutocomplete)

    def test_vendor_grid(self):
        request = testing.DummyRequest(params={'uuid': 'bogus'})
        view = departments.DepartmentsByVendorGrid(request)
        view._data = None
        self.assertIsInstance(view, departments.DepartmentsByVendorGrid)
        self.assertIsInstance(view.query(), object)
        self.assertIsInstance(view.grid(), object)

    def test_includeme(self):
        self.config.include(departments)
